# calcul de la frequence de "valeur" dans "echantillon"
# en utiliser count_eq (+ rapide)
Freq(echantillon,valeur):=count_eq(valeur,echantillon)/size(echantillon)

# on peut aussi faire ecrire l'algorithme de solution:
def Freq1(echantillon,valeur):
    # local j,total;
    total=0
    for j in echantillon:
        if j==valeur:
            total=total+1.0
    return total/len(echantillon)


# exemple d'utilisation: on genere un echantillon aleatoire de 0 et de 1
N=200
echantillon=ranv(N,2)
Freq(echantillon,1)

# le resultat devrait etre proche de la frequence theorique f=0.5
f=0.5
# on fait plusieurs fois l'experience ci-dessus et on compte
# le nombre de fois ou on est dans l'intervalle [f-1/sqrt(N),f+1/sqrt(N)]
def Ok(experiences,f,N):
    c=0
    for x in experiences:
        if abs(x-f)<1/sqrt(N):
            c=c+1
    return c

# on fait 100 fois l'experience
l=seq(Freq(ranv(N,2),1),100)
Ok(l,f,N)

# representation graphique
#histogram(l,0,0.01); droite((x=f-sqrt(1/N)),display=red); droite((x=f+sqrt(1/n)),display=red)
