# methodes des rectangles pour calculer une valeur approchee de
# l'integrale de f entre a et b, avec N subdivisions
def Rect(f,a,b,N):
    # local S,h,j
    S=0.0
    h=(b-a)/(N*1.0)
    for j in range(N):
        S=S+f(a+h+j*h)
    return S*h

# test
f(x):=sin(x)
Rect(f,0,1,100)
# on peut definir f algebriquement
Rect1(f,a,b,N):=sum(f(a+j*(b-a)/(N*1.0)),j,1,N)*(b-a)/N
Rect1(f,0,1,100)

# representation graphique
def Rectp(f,a,b,N):
    L=[]
    h=(b-a)/(N*1.0)
    for j in range(N):
        x=a+j*h
        P=polygon(point(x,0),point(x+h,0),point(x+h,f(x+h)),point(x,f(x+h)),display=filled)
        L.append(P)
    L.append(plot(f(t),t,a,b,display=red))
    return L

Rectp(f,0,1,5)
